#include "main.h"
//-----------------------------------------------------
#define LED1_ON() PORTD|=0b00001000
#define LED1_OFF() PORTD&=~(0b00001000)
#define LED2_ON() PORTD|=0b00010000
#define LED2_OFF() PORTD&=~(0b00010000)
#define LED3_ON() PORTD|=0b00100000
#define LED3_OFF() PORTD&=~(0b00100000)
#define LED4_ON() PORTD|=0b01000000
#define LED4_OFF() PORTD&=~(0b01000000)
#define LED5_ON() PORTD|=0b10000000
#define LED5_OFF() PORTD&=~(0b10000000)
#define LED6_ON() PORTB|=0b00000001
#define LED6_OFF() PORTB&=~(0b00000001);
#define LED7_ON() PORTB|=0b00000010
#define LED7_OFF() PORTB&=~(0b00000010);
#define LED8_ON() PORTB|=0b00000100
#define LED8_OFF() PORTB&=~(0b00000100);
#define LED9_ON() PORTB|=0b00001000
#define LED9_OFF() PORTB&=~(0b00001000);
#define LED10_ON() PORTB|=0b00010000
#define LED10_OFF() PORTB&=~(0b00010000);
//-----------------------------------------------------
ISR(WDT_vect)
{
  wdt_reset();
  wdt_disable();
  //LED10_ON();
}
//-----------------------------------------------------//-----------------------------------------------------
ISR(INT0_vect)
{
  
}
//-----------------------------------------------------
int main(void)
{
  wdt_reset();
  wdt_disable();
  ACSR |= (1 << ACD); //Disable ADC
  cli();
  //Disable BOD
  unsigned char rg = (MCUCR & ~(1 << BODSE)) | (1 << BODS);
  MCUCR = rg | (1 << BODSE);
  MCUCR = rg;
  DDRB = 0b00011111; //PB0-PB4 - OUT, PB5-PB7 - IN
  PORTB = 0b11100000; //PB5-PB7 - PULL UP
  DDRD = 0b11111000; //PD0-PD2 - IN (PD2 - INT0), PD3-PD7 - OUT
  PORTD = 0b00000111; //PD0-PD2 - PULL UP
  DDRC = 0b00000000; //P?0-P?7 - IN
  PORTC = 0b11111111; //P?0-P?7 - PULL UP
  EICRA |= (1<<ISC01); //falling eddge
  EIMSK |= (1<<INT0); //EXT INT INT0
  sei();
  while (1) 
  {
    LED1_ON();
    _delay_ms(1000);
    LED1_OFF();
    LED2_ON();
    _delay_ms(1000);
    LED2_OFF();
    LED3_ON();
    _delay_ms(1000);
    LED3_OFF();
    LED4_ON();
    _delay_ms(1000);
    LED4_OFF();
    LED5_ON();
    _delay_ms(1000);
    LED5_OFF();
    _delay_ms(4000);
    cli();
    MCUSR &= ~(1<<WDRF);
    wdt_enable(WDTO_8S);
    WDTCSR |= (1 << WDIE);
    set_sleep_mode(SLEEP_MODE_PWR_DOWN);
    sleep_enable();
    sei();
    sleep_cpu();
    sleep_disable();
    LED6_ON();
    _delay_ms(1000);
    LED6_OFF();
    LED7_ON();
    _delay_ms(1000);
    LED7_OFF();
    LED8_ON();
    _delay_ms(1000);
    LED8_OFF();
    LED9_ON();
    _delay_ms(1000);
    LED9_OFF();
    LED10_ON();
    _delay_ms(1000);
    LED10_OFF();
    _delay_ms(4000);
  }
}
//-----------------------------------------------------